(function(karma, requirejs, require, define) {
  var allTestFiles, pathToModule;

  allTestFiles = [];

  pathToModule = function(path) {
    return path.replace(/^\/base\//, "").replace(/\.js$/, "");
  };

  Object.keys(window.__karma__.files).forEach(function(file) {
    console.log('file', file);
    if (/Spec\.js$/.test(file)) {
      return allTestFiles.push(pathToModule(file));
    }
  });

  var getBaseUrl = function(){
    //karma.config.requirejs
    return "/base";
  }

  var getCallback = function(){
    //karma.config.requirejs
    return window.__karma__.start();
  }

  var getPath = function(){
    if(!karma.config || !karma.config.requirejs){ return []; }
    //console.log('karma.config.requirejs.paths', karma.config.requirejs.paths);
    return karma.config.requirejs.paths;
  }

  var getShim = function(){
    //karma.config.requirejs
    return {
      'global': {
        deps: ['jquery', 'text']
      }
    };
  }

  var getModuleConfig = function(){
    //karma.config.requirejs
    return {
      css: {
        useXhr: function(url, protocol, hostname, port) {
          return true;
        }
      },
      text: {
        env: 'xhr',
        useXhr: function(url, protocol, hostname, port) {
          return true;
        }
      }
    };
  }

  require.config({
    baseUrl: getBaseUrl(),
    deps: allTestFiles,
    callback: getCallback,
    paths: getPath(),
    shim: getShim(),
    config: getModuleConfig()
  });


  var deps;
  deps = ['module', 'chai', 'jquery', 'text'];
  define('karma-global', deps, function(module, chai, jquery) {
    return {
      'chai': chai,
      'expect': chai.expect,
      '$': jquery
    };
  });




})(window.__karma__, window.requirejs, window.require, window.define);
